#include "rgl.h"
#include "regis.h"

struct vec2 {
	int x, y;
};

static void flush_verts(void);
static void draw_lines(struct vec2 *v, int nverts);

static int cur_mode = -1;
#define VBUF_SIZE	64
static struct vec2 vbuf[VBUF_SIZE];
static int nverts;

void rgl_begin(int mode)
{
	cur_mode = mode;
	nverts = 0;
}

void rgl_end(void)
{
	flush_verts();
	cur_mode = -1;
}

void rgl_vertex(int x, int y)
{
	vbuf[nverts].x = x;
	vbuf[nverts].y = y;

	if(++nverts >= VBUF_SIZE) {
		flush_verts();
	}
}

static void flush_verts(void)
{
	switch(cur_mode) {
	case REGIS_LINES:
		draw_lines(vbuf, nverts);
		break;

	default:
		break;
	}
	nverts = 0;
}

static void draw_lines(struct vec2 *v, int nverts)
{
	if(nverts <= 0) return;

	regis_enter();

	regis_leave();
}
